/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_POCO                                                      */
/* Tabela : PRODOCORRE                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 13/02/2005 - Blenet Ferreira Simes                                        */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_POCO
BEFORE INSERT OR UPDATE OR DELETE
ON PRODOCORRE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPOCO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDGRPOCOR,0) <> NVL(:NEW.CDGRPOCOR,0)) OR
         (NVL(:OLD.CDOCORR,0)   <> NVL(:NEW.CDOCORR,0))   OR
         (NVL(:OLD.CDPRODUTO,0) <> NVL(:NEW.CDPRODUTO,0)) THEN
         :NEW.DTULTATUPOCO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODOCORRE', '', 'CDGRPOCOR='||:OLD.CDGRPOCOR||';CDOCORR='||:OLD.CDOCORR||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODOCORRE MODIFY DTULTATUPOCO DEFAULT SYSDATE
/